#ifdef GL_ES
precision highp float;
#endif
varying vec2 textureCoordinate;
uniform vec4 inputColor;
uniform sampler2D sTexture;
uniform float uIsFMov;
uniform float xOffset;

void main() {
    if (uIsFMov < 0.5) {
        vec4 tc = texture2D(sTexture, textureCoordinate);
        gl_FragColor = vec4(tc.r, tc.g, tc.b, tc.a);
    } else {
        vec2 texCo = vec2(textureCoordinate.x * xOffset, textureCoordinate.y);
        vec2 rgbCo = vec2(texCo.x / 2.0,texCo.y);
        vec3 rgb = texture2D(sTexture, rgbCo).rgb;
        float alpha = texture2D(sTexture, rgbCo + vec2(xOffset/2.,0.0)).r;
        gl_FragColor = vec4(rgb, alpha);
    }
}