uniform sampler2D 	tex0;
uniform sampler2D   tex1;
uniform sampler2D   tex2;
varying vec2 UV;
varying vec2 vBaseUV;
uniform float intensity;

void main() {
    vec4 uvTex = texture2D(tex0, UV);
    vec4 baseTex = texture2D(tex1, vBaseUV);
    vec4 maskTex = texture2D(tex2, vBaseUV);
    vec3 color = blendFunction(baseTex, uvTex);
    color = mix(baseTex.rgb, color, uvTex.a);
    color = mix(baseTex.rgb, color, intensity);
    if(maskTex.r < 0.5) {
	   color = baseTex.rgb;
    }
    gl_FragColor = vec4(color, 1.0);

}