#ifdef GL_ES
precision highp float;
#endif
varying vec2 vTextureCo;
varying vec2 vTextureCo1;
//背景
uniform sampler2D uTexture;
//前景
uniform sampler2D uTexture1;
//mask
uniform sampler2D uTexture2;
//smooth起始值、结束值及描边权重
uniform vec3 uLocal;
//描边颜色
uniform vec4 uColor;
//是否使用描边颜色
uniform bool uUseColor;
//是否对mask水平及垂直镜像
uniform float isFlipAxisX;
uniform float isFlipAxisY;

void main() {
    vec4 fore = texture2D( uTexture,  vTextureCo);
    vec4 back = texture2D( uTexture1, vTextureCo1);
    vec4 backMix = back.a * back + (1.0 - back.a) * fore;

    vec2 maskCoord = vTextureCo;
    if (isFlipAxisX >= 1.){
        maskCoord.x = 1. - maskCoord.x;
    }
    if (isFlipAxisY >= 1.){
        maskCoord.y = 1. - maskCoord.y;
    }

    float mask = smoothstep(uLocal.x,uLocal.y,texture2D( uTexture2, maskCoord).r);
    vec4 color = mix(backMix,fore,mask);
    if(mask == 0. || mask == 1. || !uUseColor){
        gl_FragColor = color;
    }else{
        gl_FragColor = mix(color,uColor,uLocal.z);
    }
}